diff --git a/res/res_pjsip_session.c b/res/res_pjsip_session.c
index b9448b9c1d..9e41220956 100644
--- a/res/res_pjsip_session.c
+++ b/res/res_pjsip_session.c
@@ -3027,7 +3027,8 @@ static enum sip_get_destination_result get_destination(struct ast_sip_session *s
 	}
 
 	if (!strcmp(session->exten, pickupexten) ||
-		ast_exists_extension(NULL, session->endpoint->context, session->exten, 1, NULL)) {
+		ast_exists_extension(NULL, session->endpoint->context, session->exten, 1,
+		S_COR(session->id.number.valid, session->id.number.str, NULL))) {
 		size_t size = pj_strlen(&sip_ruri->host) + 1;
 		char *domain = ast_alloca(size);
 
@@ -3048,7 +3049,8 @@ static enum sip_get_destination_result get_destination(struct ast_sip_session *s
 	 */
 	if (session->endpoint->allow_overlap && (
 		!strncmp(session->exten, pickupexten, strlen(session->exten)) ||
-		ast_canmatch_extension(NULL, session->endpoint->context, session->exten, 1, NULL))) {
+		ast_canmatch_extension(NULL, session->endpoint->context, session->exten, 1,
+		S_COR(session->id.number.valid, session->id.number.str, NULL)))) {
 		/* Overlap partial match */
 		return SIP_GET_DEST_EXTEN_PARTIAL;
 	}
